//+------------------------------------------------------------------+
//|                                            Kumo Future TREND v2.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Black
#property indicator_color3 Navy
//--- input parameters
extern int       A=8;
extern int       B=24;
extern int       C=48;

extern bool      Continuation = False;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY, 4, Lime);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY, 4, Black);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY, 4, Navy);
   SetIndexBuffer(2,ExtMapBuffer3);   
   IndicatorShortName("Kumo Future TREND ("+A+","+B+","+C+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,OldValue=0;
   double   KumoUP, KumoDW;
   int    counted_bars=IndicatorCounted();
//----
   i=Bars-counted_bars-1;           // Index of the first uncounted
   while(i>=0)                      // Loop for uncounted bars
     {
     KumoUP = iIchimoku(NULL, 0, A, B, C, MODE_SENKOUSPANA, i-B);
     KumoDW = iIchimoku(NULL, 0, A, B, C, MODE_SENKOUSPANB, i-B);
         
     if (Continuation)
         {
         if (OldValue==1 && KumoUP == KumoDW) {OldValue=1;ExtMapBuffer1[i]=1; ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if (OldValue==0 && KumoUP == KumoDW) {OldValue=0;ExtMapBuffer2[i]=1;ExtMapBuffer1[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}    
         }
     if (!Continuation)
         {        
         if (KumoUP > KumoDW) {ExtMapBuffer1[i]=1; ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if (KumoUP < KumoDW) {ExtMapBuffer2[i]=1; ExtMapBuffer1[i]=EMPTY_VALUE;ExtMapBuffer3[i]=EMPTY_VALUE;}
         if (KumoUP == KumoDW) {ExtMapBuffer3[i]=1; ExtMapBuffer2[i]=EMPTY_VALUE;ExtMapBuffer1[i]=EMPTY_VALUE;} 
         }  
     i--;     
     }       
//----
   return(0);
  }
//+------------------------------------------------------------------+